indexing
   title:       "presents an example of TIME_TOOLS class usage";
   cluster:     "timedate/examples/test_tt [timedate/examples/test_tt]";
   project:     "The Universal Time & Date UTDC";
   copyright:   "SIG Computer, 1995";
   author:      "Alexei Simonov (alex@eiffel.ru)";
   original:    22,Sep,95;
   version:     1.0;
   done_at:     "SIG Computer (info@eiffel.ru)";
   license:     "GNU Library GPL - see included readme file";
   extrnl_name: "test_tt.e";

class TEST_TIME_TOOLS

   inherit
      IO_USER

   creation
      make

   feature

      d         : DATE
      time_tools: TIME_TOOLS

      print_leap_years (a, b: INTEGER) is

         require
            b > a

         local
            i: INTEGER
            t: DATE

         do
            from
               mio.put_new_line;
               i := a
               variant
               b+1-i
            until
               i > b
            loop
               if i \\ 50 = 0 then
                  mio.put_new_line
               end
               !! t.set_date (i, 1, 1);
               if t.is_leap_year then
                  mio.put_integer ( i );
                  mio.put_string (" ");
               end;
               i := i + 1
            end;
            mio.put_new_line
         end;

      day_test (year: INTEGER) is

         local
            month, day   : INTEGER

         do
            -- make some tests with the days of a week
            !! time_tools;

            mio.put_new_line; mio.put_integer (year); mio.put_string ("----");
            from month := 1
            until month > 12
            loop
               mio.put_new_line; mio.put_string (time_tools.month_name (month));
               from day := 27
               until day > 31
               loop
                  mio.put_string (" ");
                  if time_tools.valid_date (year, month, day) then
                     !! d.set_date (year, month, day);
                     mio.put_string (time_tools.day_name (d.day_of_week))
                  else
                     mio.put_string ("invalid")
                  end;
                  day := day + 1
               end;
               month := month + 1
            end;
            mio.put_new_line;
         end;

      day_of_week_test (year, month, day: INTEGER) is

         do

            !! d.set_date(year, month, day);
            !german_time_tools! time_tools;
            put_nl ( time_tools.day_name (d.day_of_week));

            !french_time_tools! time_tools;
            put_nl ( time_tools.day_name (d.day_of_week));

            !! time_tools;
            put_nl ( time_tools.day_name (d.day_of_week));
            put_nl (x.s_date (d));
         end;

      make is

         do

            print_leap_years (1890, 2040);

            put_nl (" %N * * * Test calculation of  day of week * * * ");
            day_of_week_test (1995, 9, 18);
            day_of_week_test (666, 6, 6);
            day_of_week_test (2000, 1, 1);

            day_test (1999);
            day_test (2000);
            day_test (1996);

         end -- make

   end --  class TEST_TIME_TOOLS

